"use strict";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * @preserve Copyright 2022 - Chris West - MIT Licensed
 * 
 * When this code is first executed it will call `prismizeAll()`.  The order of
 * precedence for the options is (1) the `opt_options` passed in to
 * `prismize()`, (2) the corresponding data attributes on any `code` element
 * passed to `prismize()`, and (3) the corresponding camel cased options as
 * defined in the URL of the script tag that defines and executes this code.
 */
var _ref = function (document, undefined) {
  /** @type {PrismizeOptions} */
  var DEFAULTS = Array.from((document.currentScript.src || '').replace(/\+/g, ' ').matchAll(/[?&]([^=&#]+)(?:=([^&#]*))?/g)).reduce(function (DEFAULTS, _ref2) {
    var _ref3 = _slicedToArray(_ref2, 3),
        _ = _ref3[0],
        k = _ref3[1],
        v = _ref3[2];

    return Object.assign(DEFAULTS, _defineProperty({}, decodeURIComponent(k), v ? decodeURIComponent(v) : ''));
  }, {});
  DEFAULTS.templatePath = 'https://cdn.jsdelivr.net/npm/prismjs@[[version]]/[[path]]';
  /**
   * @typedef {Object} PrismizeOptions
   * @property {string=} className
   *   Class name to assign to the IFRAME.
   * @property {(boolean|string)=} copyable
   *   If specified as `true` the code will have a copy to clipboard button in the
   *   toolbar.  If specified as a string this will be the button text that will
   *   show in the toolbar.
   * @property {string=} downloadName
   *   The name of the file when it is downloaded via the download button.
   * @property {(boolean|string)=} downloadable
   *   If specified as `true` the code will have a download button in the
   *   toolbar.  If specified as a string this will be the button text that will
   *   show in the toolbar.
   * @property {string=} id
   *   The ID to assign to the IFRAME.
   * @property {boolean=} removeMargins
   *   If specified as `true` the margins for the main <pre> tag in the IFRAME
   *   will be removed.  Default is `false`.
   * @property {boolean=} matchBraces
   *   If specified as `true` the match braces plugin will be enabled.
   * @property {number=} maxHeight
   *   Maximum height of the content.
   * @property {(boolean|number)=} numberLines
   *   If specified as `true` or a number the lines will be numbered.  If
   *   specified as a number that will be used as the first line number to show.
   * @property {((iframe: HTMLElement, options: PrismizeOptions) => void)=} onLoad
   *   If specified this function will be called after the IFRAME is added to
   *   the DOM.
   * @property {((iframe: HTMLElement, options: PrismizeOptions) => void)=} onResize
   *   If specified this function will be called whenever the contents of the
   *   IFRAME have been resized.
   * @property {HTMLElement=} placeholder
   *   Element around where the IFRAME should be placed.  Defaults to
   *   `document.body`.
   * @property {("before"|"after"|"replace"|"end"|"start")=} placement
   *   Where to place the IFRAME in relation to `placeholder`.  Defaults to
   *   `"replace"` if `placeholder` is given, otherwise defaults to `"end"`.
   * @property {boolean=} previewColors
   *   If specified as `true` the language name will be shown in the toolbar.
   * @property {number=} resizeRate
   *   An integer indicating how often (in milliseconds) the IFRAME should be
   *   resized if necessary.  If not set will default to `100`.
   * @property {boolean=} showLanguage
   *   If specified as `true` the language name will be shown in the toolbar.
   * @property {number=} tabSize
   *   How many spaces should be used to replace tab characters.
   * @property {string=} theme
   *   If specified this will be the Prism.js theme that will be used.  Any
   *   theme that is supported in version 1 should work.
   * @property {string=} templatePath
   *   If specified this will be the Prism.js template path which will be used
   *   to pull the supporting CSS and JS.  The default is
   *   `"https://cdn.jsdelivr.net/npm/prismjs@[[version]]/[[path]]"`.  The
   *   `version` template variable should be able to be represented as
   *   `"1.X.X"`.
   */

  /**
   * Creates an IFRAME which will display the prism syntax highlighted code.
   * @param {string|HTMLElement} code
   *   Either the code to show or the element whose text content indicates the
   *   code that should be shown.  In the case that this is an element it will be
   *   used as `opt_options.placeholder` and `opt_options.placement` will be
   *   `"replace"` unless defined as something else.
   * @param {string=} language
   *   The language of `code`.
   * @param {PrismizeOptions=} opt_options
   *   An optional object containing all of the options to be set.
   */

  function prismize(code, language, opt_options) {
    var startingHeight = 0;
    var RGX_IS_HTML_BOOL = /^(false|no|off|0|true|yes|on|1|)$/i;
    var RGX_HTML_FALSE = /^(false|no|off|0)$/i;
    /** @type {PrismizeOptions} */

    var options = Object.assign({}, Object(opt_options)); // If code is an element...

    if ('string' !== typeof code) {
      var _language, _code$getAttribute, _options$id, _options$removeMargin, _options$matchBraces, _options$previewColor, _options$numberLines, _options$copyable, _options$downloadable, _options$showLanguage, _code$className, _options$className;

      // Get all options that are not already defined in the options object from
      // the data attributes.
      'copyable downloadName downloadable removeMargins matchBraces maxHeight numberLines placement previewColors resizeRate showLanguage tabSize templatePath theme'.replace(/\w+/g, function (camelCaseProp) {
        var dataProp = 'data-' + camelCaseProp.replace(/[A-Z]/g, '-$&').toLowerCase();

        if (!options.hasOwnProperty(camelCaseProp)) {
          if (code.hasAttribute(dataProp)) {
            options[camelCaseProp] = code.getAttribute(dataProp);
          } else if (DEFAULTS.hasOwnProperty(camelCaseProp)) {
            options[camelCaseProp] = DEFAULTS[camelCaseProp];
          }
        }
      }); // Handle special options.

      (_language = language) !== null && _language !== void 0 ? _language : language = (_code$getAttribute = code.getAttribute('data-prismize')) !== null && _code$getAttribute !== void 0 ? _code$getAttribute : code.getAttribute('data-language');
      options.placeholder = code;
      (_options$id = options.id) !== null && _options$id !== void 0 ? _options$id : options.id = code.id; // Handle numbers.

      options.resizeRate = +options.resizeRate; // Handle the booleans.

      options.removeMargins = !RGX_HTML_FALSE.test((_options$removeMargin = options.removeMargins) !== null && _options$removeMargin !== void 0 ? _options$removeMargin : '0');
      options.matchBraces = !RGX_HTML_FALSE.test((_options$matchBraces = options.matchBraces) !== null && _options$matchBraces !== void 0 ? _options$matchBraces : '0');
      options.previewColors = !RGX_HTML_FALSE.test((_options$previewColor = options.previewColors) !== null && _options$previewColor !== void 0 ? _options$previewColor : '0'); // Default the theme if not given.

      options.theme || (options.theme = 'default'); // If numberLines is defined as a number interpret it as such, otherwise
      // interpret it as a boolean.

      (_options$numberLines = options.numberLines) !== null && _options$numberLines !== void 0 ? _options$numberLines : options.numberLines = 'no';
      options.numberLines = RGX_IS_HTML_BOOL.test(options.numberLines) && options.numberLines != '0' ? !RGX_HTML_FALSE.test(options.numberLines) : +options.numberLines; // If copyable is defined as a non-boolean string keep it as is otherwise
      // convert it to a real boolean.

      (_options$copyable = options.copyable) !== null && _options$copyable !== void 0 ? _options$copyable : options.copyable = '0';

      if (RGX_IS_HTML_BOOL.test(options.copyable)) {
        options.copyable = !RGX_HTML_FALSE.test(options.copyable);
      } // If downloadble is defined as a non-boolean string keep it as is otherwise
      // convert it to a real boolean.


      (_options$downloadable = options.downloadable) !== null && _options$downloadable !== void 0 ? _options$downloadable : options.downloadable = '0';

      if (RGX_IS_HTML_BOOL.test(options.downloadable)) {
        options.downloadable = !RGX_HTML_FALSE.test(options.downloadable);
      } // If showLanguage is defined as a non-boolean string keep it as is otherwise
      // convert it to a real boolean.


      (_options$showLanguage = options.showLanguage) !== null && _options$showLanguage !== void 0 ? _options$showLanguage : options.showLanguage = '0';

      if (RGX_IS_HTML_BOOL.test(options.showLanguage)) {
        options.showLanguage = !RGX_HTML_FALSE.test(options.showLanguage);
      } // Make sure to mark the original element as prismized.


      code.className = (_code$className = code.className) === null || _code$className === void 0 ? void 0 : _code$className.replace(/(?:^|\s)prismize(?:\s|$)/g, ' prismized '); // If className is to be pulled from the element go ahead and do so.

      (_options$className = options.className) !== null && _options$className !== void 0 ? _options$className : options.className = code.className; // Set the starting height.

      startingHeight = +options.maxHeight ? Math.min(code.clientHeight, +options.maxHeight) : code.clientHeight; // Get the code as a string.

      code = Object.assign(document.createElement('pre'), {
        innerHTML: code.innerHTML.replace(/<br.*?>/g, '\n')
      }).textContent;
    } // Create the new IFRAME.


    var iframe = document.createElement('IFRAME');
    Object.assign(iframe.style, {
      height: startingHeight + 'px',
      width: options.width || '100%',
      border: 'none',
      display: 'block'
    }); // Assign the class name and the ID if them are given in options.

    if (options.className) iframe.className = options.className;
    if (options.id) iframe.id = options.id; // Get all of the Prism.js CSS files and the JS files.

    var _getPrismFilePaths = getPrismFilePaths(options),
        cssPaths = _getPrismFilePaths.cssPaths,
        jsPaths = _getPrismFilePaths.jsPaths; // Generate an ID that is unique to this prismized content.


    var IDENTIFIER = ('_' + Math.random() + Math.random()).replace(/\./g, '_'); // Gets the <pre> attributes as a string.

    var preClassNames = ["language-".concat(language)];
    if (options.numberLines) preClassNames.push('line-numbers');
    if (options.matchBraces) preClassNames.push('match-braces');
    var preAttributes = Object.entries({
      "class": preClassNames.join(' '),
      "data-prismjs-copy": options.copyable === true ? "Copy" : options.copyable,
      "data-start": 'number' === typeof options.numberLines ? options.numberLines : 1,
      "data-language": options.showLanguage !== true ? options.showLanguage || undefined : undefined,
      "data-label": options.downloadable ? "download" : undefined
    }).reduce(function (htmls, _ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          name = _ref5[0],
          value = _ref5[1];

      return htmls + (value != undefined ? " ".concat(name, "=\"").concat(htmlify(value), "\"") : '');
    }, ''); // Get the code that will be prismized as raw HTML.

    var escapedCode = Object.assign(document.createElement('div'), {
      innerText: unindentMin(code, {
        tabSize: +options.tabSize || undefined
      })
    }).innerHTML.replace(/<br.*?>/g, '\n'); // Get the stylesheets.

    var stylesheets = cssPaths.map(function (url) {
      return "<link rel=\"stylesheet\" href=\"".concat(url, "\" crossorigin=\"anonymous\" />");
    });
    var cssRules = 'body{margin:0;overflow:hidden;}' + (options.removeMargins ? 'pre[class*=language-]{margin:0;}' : '') + (options.maxHeight != undefined ? 'pre[class*=language-]>code{overflow-y:auto;}' : '');
    stylesheets.splice(1, 0, "<style>".concat(cssRules, "</style>")); // Get the HTML code that will be pushed into the IFRAME.

    var html = '<base target="_parent" />' + stylesheets.join('') + "<pre".concat(preAttributes, "><code>").concat(escapedCode, "</code></pre>") + (options.downloadable ? "<template id=\"download\"><button onclick=\"downloadCode()\">".concat(options.downloadable === true ? "Download" : options.downloadable, "</button></template>") : '') + '<script>(' + function () {
      // NOTE:  Reference window.document instead of just document to avoid
      //        errors when transpiling.
      var undefined = void 0;
      var _window = window,
          document = _window.document;
      var body = document.body;
      var scrollHeight;
      var maxHeight;
      /** @type {PrismizeOptions} */

      var options = ":OPTIONS:"; // Make a global function called downloadCode which will be called by
      // the download button.

      window.downloadCode = function () {
        var pre = body.querySelector('pre');
        var a = document.createElement('a');
        a.href = 'data:text/plain;charset=utf-8,' + encodeURIComponent(pre.textContent);
        a.download = options.downloadName || pre.className.replace(/(?:^(?:[^]*\s)?)language-(\S+)[^]*$/, '$1 (' + new Date().toJSON() + ').txt');
        a.style.cssText = 'position: absolute; top: -99px;';
        body.appendChild(a);
        a.click();
        body.removeChild(a);
      };

      setInterval(function () {
        // If maxHeight is defined see if the <code> tag's max height needs
        // to be updated.
        var pre = body.querySelector('pre');
        var code = pre.querySelector('code');
        var verticalMargin = body.scrollHeight - pre.offsetHeight;

        if (options.maxHeight != undefined) {
          var newMaxHeight = options.maxHeight - verticalMargin;

          if (maxHeight !== newMaxHeight) {
            maxHeight = newMaxHeight;
            code.style.maxHeight = newMaxHeight + 'px';
          }
        } // If the scroll height has changed send a message to the parent
        // window to resize this IFRAME.


        if (body.scrollHeight !== scrollHeight) {
          scrollHeight = body.scrollHeight;
          window.parent.postMessage({
            height: scrollHeight,
            id: ":IDENTIFIER:"
          }, '*');
        }
      }, options.resizeRate || 100);
    }.toString().replace('":IDENTIFIER:"', JSON.stringify(IDENTIFIER)).replace('":OPTIONS:"', JSON.stringify(options)) + ")()</script>" + jsPaths.map(function (url) {
      return "<script src=\"".concat(url, "\" crossorigin=\"anonymous\"></script>");
    }).join(''); // Show the desired page in the IFRAME.


    iframe.src = 'data:text/html;charset=UTF-8,' + encodeURIComponent(html); // Whenever a message comes through check to see if it is from the prismize
    // IFRAME and if so resize the correct IFRAME accordingly.

    window.addEventListener('message', function (e) {
      if (e.source === iframe.contentWindow) {
        var data = Object(e.data);

        if ('number' === typeof data.height && data.id === IDENTIFIER) {
          var height = data.height;

          if (options.maxHeight != undefined) {
            height = Math.min(height, +options.maxHeight);
          }

          iframe.style.height = "".concat(height, "px");
          options.onResize && options.onResize(iframe, opt_options);
        }
      }
    }); // Correctly places the IFRAME according to placeholder and placement.

    var placement = options.placement || (options.placeholder ? 'replace' : 'end');
    var placeholder = options.placeholder || document.body;
    var parent = placement === "start" || placement === "end" ? placeholder : placeholder.parentNode;
    parent.insertBefore(iframe, placement === "start" ? placeholder.firstChild : placement === "after" ? placeholder.nextSibling : placement === "end" ? null : placeholder);

    if (placement === "replace") {
      parent.removeChild(placeholder);
    } // Call onLoad if it is defined.


    options.onLoad && options.onLoad(iframe, opt_options);
  }
  /**
   * Looks for all elements that either have the "data-prismize" attribute
   * defined or the "prismize" class and calls prismize on them once DOM content
   * is loaded.
   */


  function prismizeAll() {
    function onReady() {
      document.querySelectorAll('[data-prismize],.prismize').forEach(function (elem) {
        return prismize(elem);
      });
    }

    if (/^(complete|interactive)$/.test(document.readyState)) {
      onReady();
    } else {
      document.addEventListener("DOMContentLoaded", onReady);
    }
  }
  /**
   * Takes a template string where each template variable is surrounded by two
   * sets of square brackets and returns the string with the values filled in.
   * @param {string} template 
   * @param {{[key: string]: any}} pairs 
   * @returns {string}
   */


  function fill(template, pairs) {
    var strRgx = '\\[\\[(' + Object.keys(pairs).reduce(function (arr, key) {
      return arr.concat(["".concat(key)]);
    }, []).join('|') + ')\\]\\]';
    return template.replace(new RegExp(strRgx, 'g'), function (_, key) {
      return pairs[key];
    });
  }
  /**
   * Finds the minimum indentation of all of the lines that have non-space
   * characters and removes the indentation accordingly for all indented lines.
   * @param {string} text
   *   The string containing the lines of text that should be unindented.
   * @param {{trim: boolean, tabSize: number}=} opt_options
   *   Optional, defaults to `{trim: true, tabSize: 4}`.  The `trim` property
   *   indicates if leading lines should be removed along with trailing
   *   whitespaces.  The `tabSize` property indicates how many spaces will be
   *   used to replace all tab characters.
   * @returns {string}
   *   A new version of `text` with all of the minimally indented lines having
   *   no leading spacing and all other indented lines following suit.  If
   *   `opt_options.trim` is `true` all leading lines and trailing spaces will
   *   not exist.  All tab characters will be replaced with
   *   `opt_options.tabSize` amount of space characters.
   */


  function unindentMin(text, opt_options) {
    var _opt_options$tabSize, _opt_options$trim;

    opt_options = Object(opt_options);
    var tabSize = (_opt_options$tabSize = opt_options.tabSize) !== null && _opt_options$tabSize !== void 0 ? _opt_options$tabSize : 4;
    var trim = (_opt_options$trim = opt_options.trim) !== null && _opt_options$trim !== void 0 ? _opt_options$trim : true;
    text = text.replace(/\t/g, ' '.repeat(tabSize));

    if (!/(^|[\r\n])\S/.test(text)) {
      var rgx = /(^|[\r\n])((?:(?!\r|\n)\s)+)(?=(\S)?)/g;
      var min = Infinity;

      for (var match; match = rgx.exec(text);) {
        if (match[3]) {
          min = Math.min(min, match[2].length);
        }
      }

      text = text.replace(rgx, function (_, start, spaces) {
        return start + spaces.slice(min);
      });
    }

    return trim ? text.replace(/^(\s*[\r\n]+)+|\s+$/g, '') : text;
  }
  /**
   * Takes a normal string and converts it so that any characters that need to
   * be encoded as HTML entities when interpreted as HTML will be returned.
   * @param {string} input 
   * @returns {string}
   */


  function htmlify(input) {
    return Object.assign(document.createElement('div'), {
      innerText: input
    }).innerHTML;
  }
  /**
   * Uses the options to get the correct Prism.js file paths.
   * @param {PrismizeOptions} options
   * @returns {{cssPaths: string[], jsPaths: string[]}}
   */


  function getPrismFilePaths(options) {
    var needsToolbar = options.downloadable;
    var themePath = options.theme;

    if (/^[\w\-]*$/.test(themePath)) {
      themePath = themePath !== 'default' ? '-' + options.theme : '';
      themePath = fillPath("themes/prism".concat(themePath, ".min.css"));
    }

    function fillPath(path) {
      return fill(options.templatePath, {
        version: '1.X.X',
        path: path
      });
    }

    var cssPaths = [themePath];
    var jsPaths = [fillPath('prism.min.js'), fillPath('plugins/autoloader/prism-autoloader.min.js')];
    var base;

    if (options.numberLines) {
      base = 'plugins/line-numbers/prism-line-numbers.min.';
      cssPaths.push(fillPath(base + 'css'));
      jsPaths.push(fillPath(base + 'js'));
    }

    if (options.matchBraces) {
      base = 'plugins/match-braces/prism-match-braces.min.';
      cssPaths.push(fillPath(base + 'css'));
      jsPaths.push(fillPath(base + 'js'));
    }

    if (options.previewColors) {
      base = 'plugins/inline-color/prism-inline-color.min.';
      cssPaths.push(fillPath(base + 'css'));
      jsPaths.push(fillPath(base + 'js'), fillPath('components/prism-css-extras.min.js'));
    }

    if (options.copyable) {
      jsPaths.push(fillPath('plugins/copy-to-clipboard/prism-copy-to-clipboard.min.js'));
      needsToolbar = true;
    }

    if (options.showLanguage) {
      jsPaths.push(fillPath('plugins/show-language/prism-show-language.min.js'));
      needsToolbar = true;
    }

    if (needsToolbar) {
      base = 'plugins/toolbar/prism-toolbar.min.';
      cssPaths.splice(1, 0, fillPath(base + 'css'));
      jsPaths.splice(1, 0, fillPath(base + 'js'));
    }

    return {
      cssPaths: cssPaths,
      jsPaths: jsPaths
    };
  } // Try to run prismizeAll() and then return prismize and prismizeAll() even if
  // primizeAll() fails.


  try {
    prismizeAll();
  } finally {
    return {
      prismize: prismize,
      prismizeAll: prismizeAll
    };
  }
}(window.document),
    prismize = _ref.prismize,
    prismizeAll = _ref.prismizeAll;